library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity Blinkled is
  port(clk:in std_logic;
      rst:in std_logic;
      Led1:out std_logic;
      Led2:out std_logic
      );
end Blinkled;

architecture Behavioral of Blinkled is

signal c1 : integer range 0 to 49999999 := 0; -- 0,5s bei 100MHz fosc
signal x1 : std_logic:= '0';
signal c2 : integer range 0 to 49999999 := 0; -- 0,25s bei 200MHz fosc
signal x2 : std_logic:= '0';
signal clk1: std_logic; 
signal clk2: std_logic; 

component mod_dcm
port
 (-- Clock in ports
  CLK_IN1           : in     std_logic;
  -- Clock out ports
  CLK_OUT1          : out    std_logic;
  CLK_OUT2          : out    std_logic;
  -- Status and control signals
  RESET             : in     std_logic
 );
end component;

begin
inst_mod_dcm: mod_dcm
  port map
   (-- Clock in ports
    CLK_IN1 => clk,
    -- Clock out ports
    CLK_OUT1 => clk1,
    CLK_OUT2 => clk2,
    -- Status and control signals
    RESET  => rst);
	 
   process begin
      wait until rising_edge(clk1); -- warten bis zum nchsten Takt 
      if (c1<49999999) then         -- 049999999 = 100000000 Takte = 1/2 Sekunde bei 100MHz 
          c1 <= c1+1;                -- wenn kleiner: weiterzhlen 
      else                         -- wenn Zhlerende erreicht: 
          c1 <= 0;                  -- Zhler zurcksetzen 
          x1 <= not x1;              -- und Signal x1 togglen 
      end if; 
	end process;
   Led1 <= x1;                       -- Signal x1 an Led1 ausgeben  

   process begin
      wait until rising_edge(clk2); -- warten bis zum nchsten Takt 
      if (c2<49999999) then         -- 049999999 = 100000000 Takte = 1/4 Sekunde bei 200MHz 
          c2 <= c2+1;                -- wenn kleiner: weiterzhlen 
      else                         -- wenn Zhlerende erreicht: 
          c2 <= 0;                  -- Zhler zurcksetzen 
          x2 <= not x2;              -- und Signal x2 togglen 
      end if; 
   end process; 
   Led2 <= x2;                       -- Signal x2 an Led2 ausgeben  
  
end Behavioral;
